"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ApolloDeprecatedHighlight = void 0;
var graphql_1 = require("graphql");
var utils_1 = require("./utils");
var ApolloDeprecatedHighlight = function () {
    return {
        requestDidStart: function (initialRequestContext) { return __awaiter(void 0, void 0, void 0, function () {
            var newDeprecations;
            return __generator(this, function (_a) {
                newDeprecations = [];
                return [2 /*return*/, {
                        executionDidStart: function (executionRequestContext) {
                            return __awaiter(this, void 0, void 0, function () {
                                return __generator(this, function (_a) {
                                    return [2 /*return*/, {
                                            willResolveField: function (_a) {
                                                var source = _a.source, args = _a.args, contextValue = _a.contextValue, info = _a.info;
                                                var fieldDef = (0, utils_1.getFieldDef)(info);
                                                var directive = (0, utils_1.getSchemaDirective)(info, 'deprecated');
                                                var fieldAstNode = fieldDef.astNode;
                                                if (!directive || !fieldAstNode) {
                                                    return;
                                                }
                                                var directiveValue = (0, graphql_1.getDirectiveValues)(directive, fieldAstNode);
                                                if (!directiveValue) {
                                                    return;
                                                }
                                                newDeprecations.push({
                                                    field: info.fieldName,
                                                    reason: directiveValue.reason,
                                                });
                                                return function (_error, _result) { };
                                            },
                                        }];
                                });
                            });
                        },
                        willSendResponse: function (requestContext) {
                            return __awaiter(this, void 0, void 0, function () {
                                var extensions;
                                return __generator(this, function (_a) {
                                    if (newDeprecations.length > 0) {
                                        extensions = (0, utils_1.getExtensions)(requestContext);
                                        if (!extensions.deprecations) {
                                            extensions.deprecations = [];
                                        }
                                        extensions.deprecations = extensions.deprecations.concat(newDeprecations);
                                    }
                                    return [2 /*return*/];
                                });
                            });
                        },
                    }];
            });
        }); },
    };
};
exports.ApolloDeprecatedHighlight = ApolloDeprecatedHighlight;
