"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getExtensions = exports.getSchemaDirective = exports.getFieldDef = void 0;
function getFieldDef(info) {
    var parentTypeFields = info.parentType.getFields();
    return parentTypeFields[info.fieldName];
}
exports.getFieldDef = getFieldDef;
function getSchemaDirective(info, directiveName) {
    return info.schema.getDirective(directiveName);
}
exports.getSchemaDirective = getSchemaDirective;
/**
 * Get apollo 3 and apollo 4 response extensions
 * @param requestContext
 * @returns
 */
function getExtensions(requestContext) {
    if (requestContext.response.data) {
        // apollo 3
        if (!requestContext.response.extensions) {
            requestContext.response.extensions = {};
        }
        return requestContext.response.extensions;
    }
    else if (requestContext.response.body) {
        // apollo 4
        if (requestContext.response.body.singleResult) {
            // single
            if (!requestContext.response.body.singleResult.extensions) {
                requestContext.response.body.singleResult.extensions = {};
            }
            return requestContext.response.body.singleResult.extensions;
        }
        else if (requestContext.response.body.initialResult) {
            //incremental
            // TODO: implement incremental
            return {};
        }
    }
}
exports.getExtensions = getExtensions;
